/* Conceptos:
 - Threads and variables
 - Thread sleep
 - Thread join
 - Thread scheduling
 */
/* see later */
#define _REENTRANT 0
#include <pthread.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int shared=0;

void *my_run(void *arg){
	int i;
	extern int shared;

	for(i = *(int *)arg; i>0; i--){
		printf("T2: %d\t%d\n",i,++shared);
		/*
		 * Pause thread (approx) 1 second
		 */
		sleep(1);
	}

	char *result = "fourty-two!";
	
	void *resultcpy = malloc(sizeof(result)+1);
	/*
	 * Note short test
	 */
	if (!resultcpy)
		return resultcpy;

	strcpy((char *)resultcpy,result);
	
	return resultcpy;
}

int main(){
	/*
	 * Thread identifier, will contain thread id after create call
	 */
	pthread_t created;
	extern int shared;
	int counter = 10;
	/*
	 * Second argument: attribute flags, see later
	 */
	int flag = pthread_create(&created, NULL, &my_run, (void *)&counter);
	/*
	 * Note short test
	 */	
	if(flag){
		fprintf(stderr,"Thread creation error\n");
		return(EXIT_FAILURE);
	}
	
	int i;
	for(i = counter; i>0; i--){
		printf("T1: %d\t%d\n",i,++shared);
		sleep(1);
	}

	void *resval;
	/*
	 * join takes the address to the void pointer!
	 */
	flag = pthread_join(created,&resval);
	if(flag){
		fprintf(stderr,"Thread join error\n");
		return(EXIT_FAILURE);
	}

	if (resval){
		printf("The result is %s",(char *)resval);
		free(resval);
	}
	
	return (EXIT_SUCCESS);
}