/* Conceptos:
 - Concurrent data access
 - Race Conditions
 - Thread safety
 - Reentrancy
 */
/*
 * Replaces some includes and defines to be thread safe
 */
#define _REENTRANT 0
#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int shared=0;

void *my_run(void *arg){
	int i;
	extern int shared;
	
	for(i=*(int *)arg; i>0; i--){
		int temp = shared;
		putchar('+');
		shared = temp + 1;
	}
	
	return NULL;
}

int main(){
	pthread_t created;
	extern int shared;
	int counter = 10000;
	int flag = pthread_create(&created, NULL, &my_run, (void *)&counter);
	
	if(flag != 0){
		fprintf(stderr,"Thread creation error\n");
		return(EXIT_FAILURE);
	}
	int i;
	for(i = counter; i>0; i--){
		int temp = shared;
		putchar('-');
		shared = temp - 1;
	}
	
	void *resval;
	flag = pthread_join(created,&resval);
	if(flag){
		fprintf(stderr,"Thread join error\n");
		return(EXIT_FAILURE);
	}
	
	printf("Shared = %d",shared);	
	return (EXIT_SUCCESS);
}